Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/dao/CategoryDao.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/dao/CategoryDao.java	(revision 6830)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/dao/CategoryDao.java	(revision 6831)
@@ -52,8 +52,4 @@
      */
     private static CategoryDao instance;
-    /**
-     * Cache. non utilisé pour le moment
-     */
-    private List<Category> cache;
 
     /**
@@ -81,18 +77,15 @@
      * @throws IOException 
      */
-    public List<Category> lister(boolean rafraichir, boolean recursive) throws IOException {
-	if (cache == null || rafraichir) {
-	    Document doc = Main.sessionManager.executerReturnDocument(MethodsEnum.LISTER_CATEGORIES.getLabel(),
-		    "recursive", String.valueOf(recursive));
-	    Element element = doc.getRootElement().getChild("categories");
-	    List<Element> listElement = (List<Element>) element.getChildren("category");
-	    ArrayList<Category> categories = new ArrayList<Category>();
-	    for (Element cat : listElement) {
-		Category myCat = new Category(cat);
-		categories.add(myCat);
-	    }
-	    this.cache = categories;
+    public List<Category> lister(boolean recursive) throws IOException {
+	Document doc = Main.sessionManager.executerReturnDocument(MethodsEnum.LISTER_CATEGORIES.getLabel(),
+		"recursive", String.valueOf(recursive));
+	Element element = doc.getRootElement().getChild("categories");
+	List<Element> listElement = (List<Element>) element.getChildren("category");
+	ArrayList<Category> categories = new ArrayList<Category>();
+	for (Element cat : listElement) {
+	    Category myCat = new Category(cat);
+	    categories.add(myCat);
 	}
-	return cache;
+	return categories;
     }
 
Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/dao/ImageDao.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/dao/ImageDao.java	(revision 6830)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/dao/ImageDao.java	(revision 6831)
@@ -14,5 +14,7 @@
 import fr.mael.jiwigo.om.Image;
 import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
+import fr.mael.jiwigo.transverse.enumeration.PreferencesEnum;
 import fr.mael.jiwigo.transverse.util.Outil;
+import fr.mael.jiwigo.transverse.util.preferences.PreferencesManagement;
 
 /**
@@ -157,4 +159,5 @@
 	//on convertit la miniature en string base64
 	BASE64Encoder base64 = new BASE64Encoder();
+
 	String thumbnailBase64 = base64.encode(Outil.getBytesFromFile(image.getThumbnail()));
 	//on envoie la miniature et on recupere la reponse
@@ -162,10 +165,23 @@
 		thumbnailBase64, "type", "thumb", "position", "1", "original_sum", Outil.getMD5Checksum(image
 			.getOriginale().getAbsolutePath())));
-	//on convertit le fichier original en string base64
-	String originaleBase64 = base64.encode(Outil.getBytesFromFile(image.getOriginale()));
-	//on envoie l'image originale et on recupere la reponse
-	Document reponseOriginale = (Main.sessionManager.executerReturnDocument("pwg.images.addChunk", "data",
-		originaleBase64, "type", "file", "position", "1", "original_sum", Outil.getMD5Checksum(image
-			.getOriginale().getAbsolutePath())));
+
+	//begin feature:0001827
+	Double doubleChunk = Double.parseDouble(PreferencesManagement.getValue(PreferencesEnum.CHUNK_SIZE.getLabel())) * 1000 * 1024;
+	int chunk = doubleChunk.intValue();
+	ArrayList<File> fichiersAEnvoyer = Outil.splitFile(image.getOriginale(), chunk);
+	boolean echec = false;
+	for (int i = 0; i < fichiersAEnvoyer.size(); i++) {
+	    File fichierAEnvoyer = fichiersAEnvoyer.get(i);
+	    String originaleBase64 = base64.encode(Outil.getBytesFromFile(fichierAEnvoyer));
+	    Document reponseOriginale = (Main.sessionManager.executerReturnDocument("pwg.images.addChunk", "data",
+		    originaleBase64, "type", "file", "position", String.valueOf(i), "original_sum", Outil
+			    .getMD5Checksum(image.getOriginale().getAbsolutePath())));
+	    if (!Outil.checkOk(reponseOriginale)) {
+		echec = true;
+		break;
+	    }
+	}
+	//end
+
 	//on ajoute l'image en base et on recupere la reponse
 	Document reponseAjout = (Main.sessionManager.executerReturnDocument("pwg.images.add", "file_sum", Outil
@@ -173,8 +189,12 @@
 		.getThumbnail().getCanonicalPath()), "position", "1", "original_sum", Outil.getMD5Checksum(image
 		.getOriginale().getAbsolutePath()), "categories", String.valueOf(image.getIdCategory()), "name", image
-		.getName(), "author", image.getAuteur()));
-
+		.getName(), "author", Main.sessionManager.getLogin()));
+	//	System.out.println(Main.sessionManager.executerReturnString("pwg.images.add", "file_sum", Outil
+	//		.getMD5Checksum(image.getOriginale().getAbsolutePath()), "thumbnail_sum", Outil.getMD5Checksum(image
+	//		.getThumbnail().getCanonicalPath()), "position", "1", "original_sum", Outil.getMD5Checksum(image
+	//		.getOriginale().getAbsolutePath()), "categories", String.valueOf(image.getIdCategory()), "name", image
+	//		.getName(), "author", Main.sessionManager.getLogin()));
 	boolean reussite = true;
-	if (!Outil.checkOk(reponseThumb) || !Outil.checkOk(reponseOriginale) || !Outil.checkOk(reponseAjout)) {
+	if (!Outil.checkOk(reponseThumb) || echec || !Outil.checkOk(reponseAjout)) {
 	    reussite = false;
 	}
Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/service/CategoryService.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/service/CategoryService.java	(revision 6830)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/service/CategoryService.java	(revision 6831)
@@ -73,6 +73,6 @@
      * @throws IOException 
      */
-    public List<Category> lister(boolean rafraichir, boolean recursive) throws IOException {
-	return CategoryDao.getInstance().lister(rafraichir, recursive);
+    public List<Category> lister(boolean recursive) throws IOException {
+	return CategoryDao.getInstance().lister(recursive);
     }
 
@@ -84,5 +84,5 @@
      */
     public List<Category> construireArbre() throws IOException {
-	List<Category> list = CategoryDao.getInstance().lister(false, true);
+	List<Category> list = CategoryDao.getInstance().lister(true);
 	for (Category category : list) {
 	    for (Category category2 : list) {
Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/service/ImageService.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/service/ImageService.java	(revision 6830)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/service/ImageService.java	(revision 6831)
@@ -5,10 +5,9 @@
 import java.util.List;
 
-import fr.mael.jiwigo.Main;
 import fr.mael.jiwigo.dao.ImageDao;
 import fr.mael.jiwigo.om.Image;
 import fr.mael.jiwigo.transverse.enumeration.PreferencesEnum;
 import fr.mael.jiwigo.transverse.util.ImagesUtil;
-import fr.mael.jiwigo.transverse.util.MetadataExtractor;
+import fr.mael.jiwigo.transverse.util.Outil;
 import fr.mael.jiwigo.transverse.util.preferences.PreferencesManagement;
 
@@ -67,22 +66,43 @@
     }
 
+    /**
+     * Method called to send an image to the server.
+     
+     * @param filePath
+     * @param idCategory
+     * @return
+     * @throws Exception
+     */
     public boolean creer(String filePath, Integer idCategory) throws Exception {
+	//get the byte array of the original file, to keep metadata
+	byte[] bytesFichierOriginal = Outil.getBytesFromFile(new File(filePath));
+
+	//size taken from the user's preferences
 	int widthOriginale = Integer
 		.valueOf(PreferencesManagement.getValue(PreferencesEnum.WIDTH_ORIGINALE.getLabel()));
 	int heightOriginale = Integer.valueOf(PreferencesManagement
 		.getValue(PreferencesEnum.HEIGHT_ORIGINAL.getLabel()));
+	//resize the picture (or not)
 	boolean originaleRedimensionnee = ImagesUtil.scale(filePath, "originale.jpg", widthOriginale, heightOriginale);
+	//create the thumbnail
 	ImagesUtil.scale(filePath, "thumb.jpg", 120, 90);
+	//get the thumbnail
 	File thumbnail = new File(System.getProperty("java.io.tmpdir") + "/thumb.jpg");
 	File originale = null;
 	if (originaleRedimensionnee) {
 	    originale = new File(System.getProperty("java.io.tmpdir") + "/originale.jpg");
+	    //if the original file has been resized, we put the metadata in the resized file
+	    //I use here a try catch because if the original file isn't a jpeg
+	    //the methode Outil.enrich will fail, but the procedure has to continue
+	    try {
+		byte[] fichierEnrichi = Outil.enrich(bytesFichierOriginal, Outil.getBytesFromFile(new File(System
+			.getProperty("java.io.tmpdir")
+			+ "/originale.jpg")));
+		Outil.byteToFile(System.getProperty("java.io.tmpdir") + "/originale.jpg", fichierEnrichi);
+	    } catch (Exception e) {
+	    }
 	} else {
 	    originale = new File(filePath);
-	}
-	MetadataExtractor medataExtractor = new MetadataExtractor(originale.getAbsolutePath());
-	String auteur = medataExtractor.getAuteur();
-	if (auteur == null) {
-	    auteur = Main.sessionManager.getLogin();
+
 	}
 	Image image = new Image();
@@ -90,9 +110,14 @@
 	image.setThumbnail(thumbnail);
 	image.setOriginale(originale);
-	image.setAuteur(auteur);
 	image.setIdCategory(idCategory);
+	//now we call the dao to send the image to the webservice
 	return ImageDao.getInstance().creer(image);
     }
 
+    /**
+     * Deletes the file extension
+     * @param path
+     * @return
+     */
     private String getImageName(String path) {
 	File fichier = new File(path);
Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/transverse/session/SessionManager.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/transverse/session/SessionManager.java	(revision 6830)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/transverse/session/SessionManager.java	(revision 6831)
@@ -119,4 +119,8 @@
 	    method.addParameter(parametres[i], parametres[i + 1]);
 	}
+	//begin bug:0001833
+	method.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
+	//end
+
 	try {
 	    client.executeMethod(method);
Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/transverse/util/MetadataUtil.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/transverse/util/MetadataUtil.java	(revision 6831)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/transverse/util/MetadataUtil.java	(revision 6831)
@@ -0,0 +1,224 @@
+package fr.mael.jiwigo.transverse.util;
+
+import java.io.File;
+import java.util.HashMap;
+import java.util.Iterator;
+
+import com.drew.imaging.jpeg.JpegMetadataReader;
+import com.drew.imaging.jpeg.JpegProcessingException;
+import com.drew.metadata.Directory;
+import com.drew.metadata.Metadata;
+import com.drew.metadata.MetadataException;
+import com.drew.metadata.Tag;
+
+public class MetadataUtil {
+    public static HashMap<Integer, String> getIptcMap() {
+	HashMap<Integer, String> tagNameMap = new HashMap<Integer, String>();
+	//	tagNameMap.put(new Integer(512), "Directory Version");
+	tagNameMap.put(new Integer(632), "iptc_Caption_Abstract");
+	tagNameMap.put(new Integer(634), "iptc_Writer_Editor");
+	tagNameMap.put(new Integer(617), "iptc_Headline");
+	tagNameMap.put(new Integer(552), "iptc_Special_Instructions");
+	tagNameMap.put(new Integer(592), "iptc_By_line");
+	tagNameMap.put(new Integer(597), "iptc_By_line_Title");
+	tagNameMap.put(new Integer(622), "iptc_Credit");
+	tagNameMap.put(new Integer(627), "iptc_Source");
+	tagNameMap.put(new Integer(517), "iptc_Object");
+	tagNameMap.put(new Integer(567), "iptc_Date_Created");
+	tagNameMap.put(new Integer(602), "iptc_City");
+	tagNameMap.put(new Integer(607), "iptc_Province_State");
+	tagNameMap.put(new Integer(613), "iptc_Country_Primary_Location_Code");
+	tagNameMap.put(new Integer(615), "iptc_Original_Transmission_Reference");
+	tagNameMap.put(new Integer(527), "iptc_Category");
+	tagNameMap.put(new Integer(532), "iptc_Supplemental_Category");
+	tagNameMap.put(new Integer(522), "iptc_Urgency");
+	tagNameMap.put(new Integer(537), "iptc_Keywords");
+	tagNameMap.put(new Integer(628), "iptc_Copyright_Notice");
+	tagNameMap.put(new Integer(542), "iptc_Release_Date");
+	tagNameMap.put(new Integer(547), "iptc_Release_Time");
+	tagNameMap.put(new Integer(572), "iptc_Time_Created");
+	tagNameMap.put(new Integer(577), "iptc_Originating_Program");
+	return tagNameMap;
+    }
+
+    public static HashMap<Integer, String> getExifMap() {
+	HashMap<Integer, String> tagNameMap = new HashMap<Integer, String>();
+	tagNameMap.put(new Integer(266), "exif_field_FillOrder");
+	tagNameMap.put(new Integer(269), "exif_field_DocumentName");
+	tagNameMap.put(new Integer(4096), "exif_field_RelatedImageFileFormat");
+	tagNameMap.put(new Integer(4097), "exif_field_RelatedImageWidth");
+	tagNameMap.put(new Integer(4098), "exif_field_RelatedImageLength");
+	tagNameMap.put(new Integer(342), "exif_field_TransferRange");
+	tagNameMap.put(new Integer(512), "exif_field_JPEGProc");
+	tagNameMap.put(new Integer(34665), "exif_field_ExifOffset");
+	tagNameMap.put(new Integer(37122), "exif_field_CompressedBitsPerPixel");
+	//	tagNameMap.put(new Integer(37500), "Maker Note");
+	tagNameMap.put(new Integer(40965), "exif_field_InteropOffset");
+	//	tagNameMap.put(new Integer(254), "New Subfile Type");
+	tagNameMap.put(new Integer(255), "exif_field_SubfileType");
+	//	tagNameMap.put(new Integer(256), "Thumbnail Image Width");
+	//	tagNameMap.put(new Integer(257), "Thumbnail Image Height");
+	tagNameMap.put(new Integer(258), "exif_field_BitsPerSample");
+	tagNameMap.put(new Integer(259), "exif_field_Compression");
+	tagNameMap.put(new Integer(262), "exif_field_PhotometricInterpretation");
+	tagNameMap.put(new Integer(263), "exif_field_Thresholding");
+	tagNameMap.put(new Integer(270), "exif_field_ImageDescription");
+	tagNameMap.put(new Integer(271), "exif_field_Make");
+	tagNameMap.put(new Integer(272), "exif_field_Model");
+	tagNameMap.put(new Integer(273), "exif_field_StripOffsets");
+	tagNameMap.put(new Integer(274), "exif_field_Orientation");
+	tagNameMap.put(new Integer(277), "exif_field_SamplesPerPixel");
+	tagNameMap.put(new Integer(278), "exif_field_RowsPerStrip");
+	tagNameMap.put(new Integer(279), "exif_field_StripByteCounts");
+	tagNameMap.put(new Integer(282), "exif_field_XResolution");
+	tagNameMap.put(new Integer(283), "exif_field_YResolution");
+	tagNameMap.put(new Integer(285), "exif_field_PageName");
+	tagNameMap.put(new Integer(284), "exif_field_PlanarConfiguration");
+	tagNameMap.put(new Integer(296), "exif_field_ResolutionUnit");
+	tagNameMap.put(new Integer(301), "exif_field_TransferFunction");
+	tagNameMap.put(new Integer(305), "exif_field_Software");
+	tagNameMap.put(new Integer(306), "exif_field_TakenDate");
+	tagNameMap.put(new Integer(315), "exif_field_Artist");
+	tagNameMap.put(new Integer(317), "exif_field_Predictor");
+	tagNameMap.put(new Integer(318), "exif_field_WhitePoint");
+	tagNameMap.put(new Integer(319), "exif_field_PrimaryChromaticities");
+	tagNameMap.put(new Integer(322), "exif_field_TileWidth");
+	tagNameMap.put(new Integer(323), "exif_field_TileLength");
+	tagNameMap.put(new Integer(324), "exif_field_TileOffsets");
+	tagNameMap.put(new Integer(325), "exif_field_TileByteCounts");
+	tagNameMap.put(new Integer(330), "exif_field_SubIFD");
+	tagNameMap.put(new Integer(347), "exif_field_JPEGTables");
+	tagNameMap.put(new Integer(513), "exif_field_ThumbnailOffset");
+	tagNameMap.put(new Integer(514), "exif_field_ThumbnailLength");
+	//	tagNameMap.put(new Integer(61441), "Thumbnail Data");
+	tagNameMap.put(new Integer(529), "exif_field_YCbCrCoefficients");
+	tagNameMap.put(new Integer(530), "exif_field_YCbCrSubSampling");
+	tagNameMap.put(new Integer(531), "exif_field_YCbCrPositioning");
+	tagNameMap.put(new Integer(532), "exif_field_ReferenceBlackWhite");
+	tagNameMap.put(new Integer(33421), "exif_field_CFARepeatPatternDim");
+	tagNameMap.put(new Integer(33422), "exif_field_CFAPattern2");
+	tagNameMap.put(new Integer(33423), "exif_field_BatteryLevel");
+	tagNameMap.put(new Integer(33432), "exif_field_Copyright");
+	tagNameMap.put(new Integer(33434), "exif_field_ExposureTime");
+	tagNameMap.put(new Integer(33437), "exif_field_FNumber");
+	tagNameMap.put(new Integer(33723), "exif_field_IPTC-NAA");
+	tagNameMap.put(new Integer(34675), "exif_field_ICC_Profile");
+	tagNameMap.put(new Integer(34850), "exif_field_ExposureProgram");
+	tagNameMap.put(new Integer(34852), "exif_field_SpectralSensitivity");
+	tagNameMap.put(new Integer(34853), "exif_field_GPSInfo");
+	tagNameMap.put(new Integer(34855), "exif_field_ISOSpeedRatings");
+	tagNameMap.put(new Integer(34856), "exif_field_Opto-ElectricConvFactor");
+	tagNameMap.put(new Integer(34857), "exif_field_Interlace");
+	tagNameMap.put(new Integer(34858), "exif_field_TimeZoneOffset");
+	tagNameMap.put(new Integer(34859), "exif_field_SelfTimer");
+	tagNameMap.put(new Integer(36864), "exif_field_ExifVersion");
+	tagNameMap.put(new Integer(36867), "exif_field_DateTimeOriginal");
+	//	tagNameMap.put(new Integer(36868), "Date/Time Digitized");
+	tagNameMap.put(new Integer(37121), "exif_field_ComponentsConfiguration");
+	tagNameMap.put(new Integer(37377), "exif_field_ShutterSpeedValue");
+	tagNameMap.put(new Integer(37378), "exif_field_ApertureValue");
+	tagNameMap.put(new Integer(37379), "exif_field_BrightnessValue");
+	tagNameMap.put(new Integer(37380), "exif_field_ExposureBiasValue");
+	tagNameMap.put(new Integer(37381), "exif_field_MaxApertureValue");
+	tagNameMap.put(new Integer(37382), "exif_field_SubjectDistance");
+	tagNameMap.put(new Integer(37383), "exif_field_MeteringMode");
+	tagNameMap.put(new Integer(37384), "exif_field_LightSource");
+	tagNameMap.put(new Integer(37385), "exif_field_Flash");
+	tagNameMap.put(new Integer(37386), "exif_field_FocalLength");
+	tagNameMap.put(new Integer(37387), "exif_field_FlashActivity");
+	tagNameMap.put(new Integer(37388), "exif_field_SpatialFrequencyResponse");
+	tagNameMap.put(new Integer(37389), "exif_field_Noise");
+	tagNameMap.put(new Integer(37393), "exif_field_ImageNumber");
+	tagNameMap.put(new Integer(37394), "exif_field_SecurityClassification");
+	tagNameMap.put(new Integer(37395), "exif_field_ImageHistory");
+	tagNameMap.put(new Integer(37396), "exif_field_SubjectLocation");
+	tagNameMap.put(new Integer(41493), "exif_field_ExposureIndex");
+	tagNameMap.put(new Integer(37398), "exif_field_TIFF-EPStandardID");
+	tagNameMap.put(new Integer(37510), "exif_field_UserComment");
+	tagNameMap.put(new Integer(37520), "exif_field_SubSecTime");
+	tagNameMap.put(new Integer(37521), "exif_field_SubSecTimeOriginal");
+	tagNameMap.put(new Integer(37522), "exif_field_SubSecTimeDigitized");
+	tagNameMap.put(new Integer(40960), "exif_field_FlashpixVersion");
+	tagNameMap.put(new Integer(40961), "exif_field_ColorSpace");
+	tagNameMap.put(new Integer(40962), "exif_field_ExifImageWidth");
+	//	tagNameMap.put(new Integer(40963), "Exif Image Height");
+	tagNameMap.put(new Integer(40964), "exif_field_RelatedSoundFile");
+	tagNameMap.put(new Integer(41483), "exif_field_FlashEnergy");
+	tagNameMap.put(new Integer(41484), "exif_field_SpatialFrequencyResponse");
+	tagNameMap.put(new Integer(41486), "exif_field_FocalPlaneXResolution");
+	tagNameMap.put(new Integer(41487), "exif_field_FocalPlaneYResolution");
+	tagNameMap.put(new Integer(41488), "exif_field_FocalPlaneResolutionUnit");
+	tagNameMap.put(new Integer(41492), "exif_field_SubjectLocation");
+	tagNameMap.put(new Integer(37397), "exif_field_ExposureIndex");
+	tagNameMap.put(new Integer(41495), "exif_field_SensingMethod");
+	tagNameMap.put(new Integer(41728), "exif_field_FileSource");
+	tagNameMap.put(new Integer(41729), "exif_field_SceneType");
+	tagNameMap.put(new Integer(41730), "exif_field_CFAPattern");
+	tagNameMap.put(new Integer(41985), "exif_field_CustomRendered");
+	tagNameMap.put(new Integer(41986), "exif_field_ExposureMode");
+	tagNameMap.put(new Integer(41987), "exif_field_WhiteBalance");
+	tagNameMap.put(new Integer(41988), "exif_field_DigitalZoomRatio");
+	tagNameMap.put(new Integer(41989), "exif_field_FocalLengthIn35mmFormat");
+	tagNameMap.put(new Integer(41990), "exif_field_SceneCaptureType");
+	tagNameMap.put(new Integer(41991), "exif_field_GainControl");
+	tagNameMap.put(new Integer(41992), "exif_field_Contrast");
+	tagNameMap.put(new Integer(41993), "exif_field_Saturation");
+	tagNameMap.put(new Integer(41994), "exif_field_Sharpness");
+	tagNameMap.put(new Integer(41995), "exif_field_DeviceSettingDescription");
+	tagNameMap.put(new Integer(41996), "exif_field_SubjectDistanceRange");
+	//	tagNameMap.put(new Integer(40093), "Windows XP Author");
+	//	tagNameMap.put(new Integer(40092), "Windows XP Comment");
+	//	tagNameMap.put(new Integer(40094), "Windows XP Keywords");
+	//	tagNameMap.put(new Integer(40095), "Windows XP Subject");
+	//	tagNameMap.put(new Integer(40091), "Windows XP Title");
+	tagNameMap.put(new Integer(280), "exif_field_MinSampleValue");
+	tagNameMap.put(new Integer(281), "exif_field_MaxSampleValue");
+	return tagNameMap;
+    }
+
+    public static HashMap<String, String> getTagsHashMap(String fichier) throws JpegProcessingException,
+	    MetadataException {
+	File jpegFile = new File(fichier);
+	Metadata metadata = JpegMetadataReader.readMetadata(jpegFile);
+	Iterator directories = metadata.getDirectoryIterator();
+	HashMap<String, String> mapTags = new HashMap<String, String>();
+	while (directories.hasNext()) {
+	    Directory directory = (Directory) directories.next();
+	    Iterator tags = directory.getTagIterator();
+	    if (directory.getName().equals("Exif") || directory.getName().equals("Iptc")) {
+		while (tags.hasNext()) {
+		    Tag tag = (Tag) tags.next();
+		    if (tag.getDirectoryName().equals("Exif")) {
+			for (Integer key : MetadataUtil.getExifMap().keySet()) {
+			    if (tag.getTagType() == key) {
+				mapTags.put(MetadataUtil.getExifMap().get(key), tag.getDescription());
+			    }
+			}
+		    } else {
+			for (Integer key : MetadataUtil.getIptcMap().keySet()) {
+			    if (tag.getTagType() == key) {
+				mapTags.put(MetadataUtil.getIptcMap().get(key), tag.getDescription());
+			    }
+			}
+		    }
+		}
+	    }
+	}
+	return mapTags;
+    }
+
+    public static void main(String[] args) {
+	try {
+	    HashMap<String, String> map = getTagsHashMap("/home/mael/Images/exif.JPG");
+	    for (String key : getTagsHashMap("/home/mael/Images/exif.JPG").keySet()) {
+		System.out.println(key + " -> " + map.get(key));
+	    }
+	} catch (JpegProcessingException e) {
+	    // TODO Auto-generated catch block
+	    e.printStackTrace();
+	} catch (MetadataException e) {
+	    // TODO Auto-generated catch block
+	    e.printStackTrace();
+	}
+    }
+}
Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/transverse/util/Outil.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/transverse/util/Outil.java	(revision 6830)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/transverse/util/Outil.java	(revision 6831)
@@ -2,7 +2,10 @@
 
 import java.io.BufferedInputStream;
+import java.io.ByteArrayInputStream;
+import java.io.ByteArrayOutputStream;
 import java.io.DataInputStream;
 import java.io.File;
 import java.io.FileInputStream;
+import java.io.FileOutputStream;
 import java.io.IOException;
 import java.io.InputStream;
@@ -14,5 +17,14 @@
 import java.net.URLClassLoader;
 import java.security.MessageDigest;
-
+import java.util.ArrayList;
+
+import org.apache.sanselan.Sanselan;
+import org.apache.sanselan.common.IImageMetadata;
+import org.apache.sanselan.formats.jpeg.JpegImageMetadata;
+import org.apache.sanselan.formats.jpeg.JpegPhotoshopMetadata;
+import org.apache.sanselan.formats.jpeg.exifRewrite.ExifRewriter;
+import org.apache.sanselan.formats.jpeg.iptc.JpegIptcRewriter;
+import org.apache.sanselan.formats.jpeg.iptc.PhotoshopApp13Data;
+import org.apache.sanselan.formats.tiff.write.TiffOutputSet;
 import org.jdom.Document;
 import org.jdom.JDOMException;
@@ -209,3 +221,76 @@
 	return result.toString();
     }
+
+    /**
+     * Function that splits a file 
+     * @param fichier the file to split
+     * @param size the size of the resulting chunks
+     * @return the list of files
+     * @throws IOException
+     */
+    //feature:0001827
+    public static ArrayList<File> splitFile(File fichier, int size) throws IOException {
+	FileInputStream fis = new FileInputStream(fichier);
+	byte buffer[] = new byte[size];
+	ArrayList<File> listFichiers = new ArrayList<File>();
+	int count = 0;
+	while (true) {
+	    int i = fis.read(buffer, 0, size);
+	    if (i == -1)
+		break;
+	    File file = new File(System.getProperty("java.io.tmpdir") + "/tempcut" + count);
+	    listFichiers.add(file);
+	    FileOutputStream fos = new FileOutputStream(file);
+	    fos.write(buffer, 0, i);
+	    fos.flush();
+	    fos.close();
+
+	    ++count;
+	}
+	return listFichiers;
+    }
+
+    /**
+     * Function used to put the exif and iptc metadata from one image to another
+     * @param enriched original image where the metadata comes from
+     * @param naked image where to put metadata
+     * @return enriched image
+     * @throws Exception
+     */
+    public static byte[] enrich(byte[] enriched, byte[] naked) throws Exception {
+
+	// read IPTC metadata from the original enriched image
+	IImageMetadata metadata = Sanselan.getMetadata(enriched);
+	JpegImageMetadata jpegMetadata = (JpegImageMetadata) metadata;
+	JpegPhotoshopMetadata photoshopMetadata = jpegMetadata.getPhotoshop();
+	if (photoshopMetadata == null) {
+	    return naked;
+	}
+
+	PhotoshopApp13Data data = photoshopMetadata.photoshopApp13Data;
+
+	// read the EXIF metadata from the parsed JPEG metadata
+	TiffOutputSet outputSet = jpegMetadata.getExif().getOutputSet();
+
+	// enrich the naked byte[] with EXIF metadata
+	ExifRewriter writer = new ExifRewriter();
+	ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
+	writer.updateExifMetadataLossless(naked, outputStream, outputSet);
+
+	// enrich the partially clothed byte[] with IPTC metadata
+	InputStream src = new ByteArrayInputStream(outputStream.toByteArray());
+	ByteArrayOutputStream dest = new ByteArrayOutputStream();
+	new JpegIptcRewriter().writeIPTC(src, dest, data);
+
+	// return the fully clothed image as a byte[]
+	return dest.toByteArray();
+    }
+
+    public static void byteToFile(String fichier, byte[] bytes) throws IOException {
+	FileOutputStream fos = new FileOutputStream(fichier);
+	fos.write(bytes);
+	fos.flush();
+	fos.close();
+
+    }
 }
